unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Label1: TLabel;
    LView: TListView;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DropFiles;
    procedure Doit(const AFileName: String; const ALevel: Integer);
  protected
    procedure CreateParams(var Params: TCreateParams);override;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
    ShellApi, ComObj, Info;

//-----------------------------------------------------------------------------
//  GNXv[̃hbOAhhbv󂯕t悤ɂ
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TForm1.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    Params.ExStyle := Params.EXStyle or WS_EX_ACCEPTFILES;
end;

//-----------------------------------------------------------------------------
//  GNXv[hbvꂽ̏
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TForm1.WMDropFiles(var Msg: TWMDropFiles);
var
    LFileName: array[0..MAX_PATH] of Char;
    i, LCount: integer;
begin
    Screen.Cursor := crHourGlass;

    //  hbvꂽt@C̐擾
    LCount := DragQueryFile(Msg.Drop, DWORD(-1), LFileName, SizeOf(LFileName));
    for i := 0 to LCount - 1 do
    begin
        //  ꂼ̃t@C擾
        DragQueryFile(Msg.Drop, i, LFileName, SizeOf(LFileName));

        //  
        Doit(LFileName, 0);
    end;
    //  hbv
    DragFinish(Msg.Drop);

    Screen.Cursor := crDefault;
end;

//-----------------------------------------------------------------------------
//  t@Cƃ^CgrĈقȂ΃Xgɒǉ(tH_͌@)
//  Subject: [Delphi-ML:4452] Re: fBNg\𓾂ɂ́H
procedure TForm1.Doit(const AFileName: String; const ALevel: Integer);
var
    LPath: String;
    LRec: TSearchRec;
    LShell: OleVariant;
    LFolder: OleVariant;
    LFolderItem: OleVariant;
    LTitle: String;
    LListItem: TListItem;
begin
    //  ꂪt@CȂ珈u
    if (FileExists(AFileName)) then
    begin
        //  ShellIuWFNg擾
        LShell := CreateOleObject('Shell.Application');
        //  ̃tH_FolderIuWFNg擾
        LFolder := LShell.NameSpace(OleVariant(ExtractFilePath(AFileName)));
        //  ACe擾
        LFolderItem := LFolder.ParseName(OleVariant(ExtractFileName(AFileName)));

        //  ^Cg擾
        LTitle := LFolder.GetDetailsOf(LFolderItem, 10);
        //  ^CgȂΖ
        if (LTitle <> '') and (LTitle <> ChangeFileExt(ExtractFileName(AFileName), '')) then
        begin
            //  o
            LListItem := LView.Items.Add;
            LListItem.Caption := LTitle;
            LListItem.SubItems.Add(ChangeFileExt(ExtractFileName(AFileName), ''));
            LListItem.SubItems.Add(ExtractFileExt(AFileName));
            LListItem.SubItems.Add(ExtractFilePath(AFileName));

            if (LView.Column[0].Width < LView.Canvas.TextWidth(LTitle) + 30) then
            begin
                LView.Column[0].Width := LView.Canvas.TextWidth(LTitle) + 30;
            end;
            if (LView.Column[1].Width < LView.Canvas.TextWidth(ExtractFileName(AFileName)) + 10) then
            begin
                LView.Column[1].Width := LView.Canvas.TextWidth(ExtractFileName(AFileName)) + 10;
            end;
            if (LView.Column[3].Width < LView.Canvas.TextWidth(ExtractFilePath(AFileName)) + 10) then
            begin
                LView.Column[3].Width := LView.Canvas.TextWidth(ExtractFilePath(AFileName)) + 10;
            end;

            LListItem.Checked := True;
        end;

        LFolder := Unassigned;
        LShell := Unassigned;
    end

    //  tH_Ȃ@i
    else if (DirectoryExists(AFileName)) then
    begin
        LPath := IncludeTrailingPathDelimiter(AFileName);

        // Ȃ񂩓Ă邩ȁH
        if FindFirst(LPath + '*.*', faAnyFile, LRec) = 0 then
        begin
            try
                repeat
                    // tH_ƐetH_͖
                    if (LRec.Name = '.') or (LRec.Name = '..') then Continue;

                    //  t@CȂċAĂяo
                    if (FileExists(LPath + LRec.Name)) then
                    begin
                        Doit(LPath + LRec.Name, ALevel + 1);
                    end

                    //  tH_ȂKw`FbN
                    else if (ALevel <= UpDown1.Position) then
                    begin
                        Doit(LPath + LRec.Name, ALevel + 1);
                    end;
                until
                    // ǂ܂ł
                    FindNext(LRec) <> 0;
            finally
                // Еt
                FindClose(LRec);
            end;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  ̕ύXs
procedure TForm1.Button1Click(Sender: TObject);
var
    i, j: Integer;
    LListItem: TListItem;
    LFolder: String;
    LExt: String;
    LOldName: String;
    LNewName: String;
    LTmpName: String;
begin
    for i := LView.Items.Count - 1 downto 0 do
    begin
        j := 0;
        if (LView.Items[i].Checked) then
        begin
            LListItem := LView.Items[i];
            LFolder := IncludeTrailingPathDelimiter(LListItem.SubItems[2]);
            LExt := LListItem.SubItems[1];
            LOldName := LListItem.SubItems[0];
            LNewName := LListItem.Caption;
            LTmpName := LNewName;

            if (FileExists(LFolder + LOldName + LExt)) then
            begin
                while FileExists(LFolder + LTmpName + LExt) do
                begin
                    LTmpName := LNewName + '_' + IntToHex(j, 2);
                    Inc(j);
                end;

                LOldName := LFolder + LOldName + LExt;
                LNewName := LFolder + LTmpName + LExt;

                if (RenameFile(LOldName, LNewName)) then
                begin
                    LView.Items.Delete(i);
                end;
            end;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TForm1.Button2Click(Sender: TObject);
begin
    LView.Clear();
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TForm1.FormCreate(Sender: TObject);
begin
    SetFormCaption(Self);
end;

//-----------------------------------------------------------------------------
//  o[W\
procedure TForm1.Button3Click(Sender: TObject);
begin
    OpenInfoForm();
end;

end.
